@Library('js-jenkins-library')

def dockerContainerName = 'js-application'

pipeline {
    environment {
        IMAGE_NAME = ''
    }
    agent any
    tools {nodejs "nodejs"}
    stages {
        stage('Build') {
            steps {
                script {
                    dir('app') {
                        npmInstall()
                    }
                }
            }
        }
        stage('Test') {
            steps {
                script {
                    dir('app') {
                        testing()
                    }
                }
            }
        }
        stage('Increment version') {
            steps {
                script {
                    dir('app') {
                        IMAGE_NAME = retrievingVersion()
                    }
                }
            }
        }
        stage('Build image') {
            when {
                expression {
                    BRANCH_NAME == 'master'
                }
            }
            steps {
                dockerLogin()
                buildImage "tmoretto17/my-app:$IMAGE_NAME"
                dockerPush "tmoretto17/my-app:$IMAGE_NAME"
            }
        }
        stage('Version update') {
            steps {
                script {
                    dir('app') {
                        incrementVersion()
                    }
                    commitAndPush "gitlab.com/moretto.tommaso/js-application-ci-cd.git"
                }
            }
        }
        stage("deploy") {
            when {
                expression {
                    BRANCH_NAME == 'master'
                }
            }
            steps {
                script {
                    dockerRun(IMAGE_NAME, dockerContainerName, 'ec2-server-key', "ec2-user@3.126.146.191")

                    /*def dockerStop = "docker stop $dockerContainerName"
                    def dockerRm = "docker rm $dockerContainerName"
                    def dockerRun = "docker run --name $dockerContainerName -d -p 3000:3000 tmoretto17/my-app:$IMAGE_NAME"
                    sshagent(['ec2-server-key']) {
                        sh "ssh -o StrictHostKeyChecking=no ec2-user@3.126.146.191 '${dockerStop}; ${dockerRm}; ${dockerRun}; docker ps;'"
                    }*/
                }
            }
        }
    }
}
